package org.processmining.traceclusteringfsm.algorithms;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.apache.commons.io.LineIterator;
import org.processmining.traceclusteringfsm.models.FreqSeqPatterns;

import gnu.trove.set.hash.THashSet;
import pm.io.UtilIO;

public abstract class FSPAlgorithmAbstract implements FSPAlgorithm {

	public FreqSeqPatterns readAndWritePatternSeqs(String filePath) {
//		String filePath = "C:\\Users\\Lu000017\\Dropbox\\eclipse-workspace\\spmf\\output_AlgFAST.txt";
		LineIterator it = UtilIO.readFile(filePath);

		FreqSeqPatterns fspatterns = new FreqSeqPatterns();
		Map<Integer, Integer> mapPatternLenght2FreqMap = fspatterns.getMapPatternLenght2FreqMap();
		Map<Integer, Integer> mapPatternSet2FreqMap = fspatterns.getMapPatternSet2FreqMap();
		Map<Integer, Integer> mapAct2NumPatterns = fspatterns.getMapAct2NumPatterns();

//		List<List<Integer>> patterns = new ArrayList<>();

		while (it.hasNext()) {
			String line = it.nextLine();
//			Sequences seqs = new Sequences("");

			String[] values = line.split(" ");

			List<Integer> pattern = new ArrayList<>();
			Set<Integer> patternSet = new THashSet<>();
			for (String s : values) {
				int act = Integer.parseInt(s);
				if (act == -1) {

				} else if (act == -2) {
					break;
				} else {
					pattern.add(act);

					if (!patternSet.contains(act)) {
						increaseByOne(mapAct2NumPatterns, act);
					}
					patternSet.add(act);
				}
			}

//			if(pattern.size() > 14) {
//			for (Integer a : pattern) {
//				writerPatternLog.println(caseId + ";" + bimapAct2Int.inverse().get(a));
//			}
//			}
			//
			fspatterns.addPattern(pattern);
			increaseByOne(mapPatternLenght2FreqMap, pattern.size());
			increaseByOne(mapPatternSet2FreqMap, patternSet.size());

//			caseId++;
		}
		printMap(mapPatternLenght2FreqMap, System.out);
		printMap(mapAct2NumPatterns, System.out);
		printMap(mapPatternSet2FreqMap, System.out);

		return fspatterns;
	}

	

	private void increaseByOne(Map<Integer, Integer> mapPatternLenght2FreqMap, Integer key) {
		Integer freq = mapPatternLenght2FreqMap.get(key);
		mapPatternLenght2FreqMap.put(key, freq != null ? freq + 1 : 1);
	}

	private void printMap(Map<Integer, Integer> mapPatternLenght2FreqMap, PrintStream out) {
		for (Entry<Integer, Integer> entry : mapPatternLenght2FreqMap.entrySet()) {
			out.println(entry.getKey() + ":" + entry.getValue());
		}
	}

}
