package org.processmining.traceclusteringfsm.algorithms;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.LineIterator;
import org.processmining.traceclusteringfsm.models.FreqSeqPatterns;
import org.processmining.traceclusteringfsm.models.PIDresult;
import org.processmining.traceclusteringfsm.models.ParamEvaluation;
import org.processmining.traceclusteringfsm.models.Parameter;

import com.google.common.collect.BiMap;
import com.google.common.collect.HashBiMap;

import ca.pfv.spmf.algorithms.sequentialpatterns.fournier2008_seqdim.ItemSimple;
import ca.pfv.spmf.algorithms.sequentialpatterns.fournier2008_seqdim.Itemset;
import ca.pfv.spmf.algorithms.sequentialpatterns.fournier2008_seqdim.Sequence;
import ca.pfv.spmf.algorithms.sequentialpatterns.fournier2008_seqdim.SequenceDatabase;
import gnu.trove.map.hash.THashMap;
import gnu.trove.set.hash.THashSet;
import pm.io.UtilIO;

public class VUmcDataPrepForSeqs {

//	private LineIterator readTable(String filePath) {
//
//	}

	public void read() {
//		String[] years = new String[] {"2017", "2016", "2015", /* "2014", "2013"*/};
		String[] years = new String[] {"2017", "2016", "2015",  "2014", "2013"};
//		String[] years = new String[] { "2014", "2013"};
		int[] ks = new int[] {10 ,  15};
		double[] minsupps = new double[] {0.2};
		int ksample = 15;
//		double d = 0.2;
		for(String year : years) {
//			for(int ksample : ks) {
				for(double d : minsupps) {
			
		String filePath = "C:\\Users\\Lu000017\\Dropbox\\_Data\\2018 VUmc\\20190211 VUmc-patientgrouping\\vumc_DBCVerrichtingen"
				+ year + "actFiltered.csv";

//		String gtfilePath = "C:\\Users\\Lu000017\\Dropbox\\_Data\\DataVUmc\\GT\\2017,Nierschade.txt";
		String gtfilePath = "C:\\Users\\Lu000017\\Dropbox\\_Data\\DataVUmc\\GT\\";

//		String year = "2015";
//		String pGroup = "Nierschade";
//		String pGroup = "Diabetes";
		String pGroup = "Hoofdhals";
		LineIterator it = UtilIO.readFile(filePath);

		Set<String> gtids = getGroundTruthIds(gtfilePath + year + "," + pGroup + ".txt");
		System.out.println("gt size " + gtids.size());

		Parameter param = new Parameter();
		param.setDataName(pGroup + year);
		param.setK(ksample);
		param.setMinSupp(d);
		param.setAlg(new FSPAlgoFast());

		int indexPid = 0;
		int indexAct = 4;
		int indexDBC = 7;

		Set<String> pids = new THashSet<>();
		Set<String> acts = new THashSet<>();
		String line = it.nextLine();
		Map<String, Set<String>> mapAct2caseFreq = new THashMap<String, Set<String>>();

//		Set<String> skipActs = new THashSet<String>();

//		skipActs.add("EERSTE POLIKLINIEKBEZOEK");
//		skipActs.add("HERHAALPOLIKLINIEKBEZOEK");
//		skipActs.add("ORDERTAR.KLIN-CHEM.EN MICROBIOL.LAB.ONDERZ-INCL.AFN.BLOED");
//		skipActs.add("TELEFONISCH CONSULT                            KOSTEN OUT");


		//print column
//		PrintStream writerGTCSV = UtilIO.createWriter(filePath.substring(0, filePath.length()-4) + "_GT" + pGroup+year+".csv");
//		writerGTCSV.println(line);
		
		while (it.hasNext()) {
			line = it.nextLine();
			// do something with line

			// nrLines++;
			// writer.println(line);
			// values = line.split(";");
			String[] values = line.split(";");

			String pid = values[indexPid];
			String dbc = values[indexDBC];
			String activity = values[indexAct];

//			if (skipActs.contains(activity)) {
//				continue;
//			}

			String label = getLabel(activity, dbc);
			pids.add(pid);
			acts.add(label);

			Set<String> ids = mapAct2caseFreq.get(label);
			if (ids == null) {
				ids = new THashSet<String>();
			}
			ids.add(pid);
			mapAct2caseFreq.put(label, ids);

			
//			if(gtids.contains(pid)) {
//				writerGTCSV.println(line);
//				writerGTCSV.flush();
//			}
		}
//		writerGTCSV.close();

		/*
		 * Initialize bookkeeping variables
		 */
		Map<Integer, Sequence> mapId2Sequence = new THashMap<>();

		BiMap<String, Integer> bimapAct2Int = HashBiMap.create();
		BiMap<String, Integer> bimapPid2Int = HashBiMap.create();
		for (String act : acts) {
			bimapAct2Int.put(act, bimapAct2Int.size());
		}

		for (String pid : gtids) {
			int id = bimapPid2Int.size();
			bimapPid2Int.put(pid, id);

			mapId2Sequence.put(id, new Sequence(id));
		}

		/*
		 * Create trace seqs for k-sample
		 */
		it = UtilIO.readFile(filePath);
		line = it.nextLine();
		while (it.hasNext()) {
			line = it.nextLine();

			String[] values = line.split(";");
			String pid = values[indexPid];
			String dbc = values[indexDBC];
			String activity = values[indexAct];
//			if (skipActs.contains(activity)) {
//				continue;
//			}

			String label = getLabel(activity, dbc);

			// Create "Activity set"
			Itemset actItems = new Itemset();
			actItems.addItem(new ItemSimple(bimapAct2Int.get(label)));
			// Add to the trace
			if (gtids.contains(pid)) {
				Sequence sequence = mapId2Sequence.get(bimapPid2Int.get(pid));
				sequence.addItemset(actItems);
//				if (sequence.size() == 0 || !isRepetitation(bimapAct2Int, label, sequence)) {
//
//					sequence.addItemset(actItems);
//				}

			}

		}
//		AlgoBIDEPlus alg = new AlgoBIDEPlus(0.9);
//		AlgoFSGP alg = new AlgoFSGP();

		int intKpop = param.getK();
		SequenceDatabase database = new SequenceDatabase();
		String[] ids = gtids.toArray(new String[gtids.size()]);

		Set<String> kpidsforEval = new THashSet<>();

		for (Entry<Integer, Sequence> entry : mapId2Sequence.entrySet()) {
			if (entry.getValue().size() == 0) {
				bimapPid2Int.inverse().get(entry.getKey());
				System.err.println(entry.getKey());
			}
			if (database.size() >= intKpop) {
				break;
			}
			kpidsforEval.add(bimapPid2Int.inverse().get(entry.getKey()));
			database.addSequence(entry.getValue());
		}
		for (int i = 0; i < ids.length; i++) {
			kpidsforEval.add(ids[i]);
			if (kpidsforEval.size() >= 30) {
				break;
			}
		}

		String foldername = getFolderName(year, pGroup, param);

		new File("./out/" + foldername + "/").mkdir();
		String sequencesFile = "./out/" + foldername + "/kSequences.txt";

		PrintStream writer = UtilIO.createWriter(sequencesFile);
		write(database, writer);

		PrintStream writerAct = UtilIO.createWriter("./out/" + foldername + "/mapAct2int.txt");
		printMap(bimapAct2Int, mapAct2caseFreq, writerAct);

		// output file path
		String outputPath = "./out/" + foldername + "/outputPattern.txt";
		String outputPathClo = "./out/" + foldername + "/outputPatternClo.txt";

		// Create an instance of the algorithm with minsup = 50 %
		float minsup = param.getMinSupp();
		FSPAlgorithm alg = param.getAlg();
		FreqSeqPatterns patterns = alg.runAlgorithm(sequencesFile, outputPath, minsup);

		FreqSeqPatterns cloPatterns = (new FSPAlgoCloFast()).runAlgorithm(sequencesFile, outputPathClo, minsup);

		/*
		 * Iterate case and build sequences
		 * 
		 */
		Set<Integer> patternActs = patterns.getLabelSet();
//		Map<Integer, Integer> mapPatternAct2Index = new THashMap<>();

		/*
		 * 3rd iteration to match other patients to frequent sequence patterns
		 */
		it = UtilIO.readFile(filePath);
		Map<String, Set<Integer>> mapPid2Sets = new THashMap<>();
		Map<String, List<Integer>> mapPid2Seq = new THashMap<>();
		Map<String, Integer> mapPid22Pat = new THashMap<>();
//		Map<String, Integer> mapPid25Pat = new THashMap<>();

		Map<String, Integer> mapPid2MPat = new THashMap<>();

		while (it.hasNext()) {
			line = it.nextLine();
			// do something with line

			// nrLines++;
			// writer.println(line);
			// values = line.split(";");
			String[] values = line.split(";");

			String pid = values[indexPid];
			String dbc = values[indexDBC];
			String activity = values[indexAct];

			String label = getLabel(activity, dbc);

			if (!patternActs.contains(bimapAct2Int.get(label))) {
				continue;
			}

			List<Integer> seq = mapPid2Seq.get(pid);
			Set<Integer> actSet = mapPid2Sets.get(pid);
			if (actSet == null) {
				actSet = new THashSet<Integer>();
				seq = new ArrayList<Integer>();
			}
			actSet.add(bimapAct2Int.get(label));
			seq.add(bimapAct2Int.get(label));
			mapPid2Sets.put(pid, actSet);
			mapPid2Seq.put(pid, seq);

		}

		for (List<Integer> pattern : patterns.getPatterns()) {
			if (pattern.size() == 2 || pattern.size() == 3) {
				for (Entry<String, List<Integer>> entry : mapPid2Seq.entrySet()) {
					boolean valid = checkPattern(pattern, entry.getValue());

					if (pattern.size() == 2) {
						increasePatternFreq(mapPid22Pat, entry, valid);
					} else if (pattern.size() == 3) {
//						increasePatternFreq(mapPid25Pat, entry, valid);
					} else {
//						increasePatternFreq(mapPid2MPat, entry, valid);
//						.put(pid, )
					}
				}
			}
		}
		int maxSize = cloPatterns.getMaxSize();
		for (List<Integer> pattern : cloPatterns.getPatterns()) {
//			if (pattern.size() == maxSize) {
				for (Entry<String, List<Integer>> entry : mapPid2Seq.entrySet()) {
					boolean valid = checkPattern(pattern, entry.getValue());

//					if (pattern.size() == 2) {
//						increasePatternFreq(mapPid22Pat, entry, valid);
//					} else if (pattern.size() == 3) {
//						increasePatternFreq(mapPid25Pat, entry, valid);
//					} else {
					increasePatternFreq(mapPid2MPat, entry, valid);
//						.put(pid, )
//					}
				}
//			}
		}

		PrintStream writerRes = UtilIO.createWriter("./out/" + foldername + "/resF1raw.txt");

		List<PIDresult> reslist = new ArrayList<>();
		for (Entry<String, Set<Integer>> entry : mapPid2Sets.entrySet()) {
//			List<String> res = new ArrayList<>();
//			res.add(e)
			StringBuilder builder = new StringBuilder();
			builder.append(entry.getKey() + ";");
			builder.append(entry.getValue().size() + ";");
			builder.append(mapPid22Pat.get(entry.getKey()) + ";");
//			builder.append(mapPid25Pat.get(entry.getKey()) + ";");
			builder.append(mapPid2MPat.get(entry.getKey()) + ";");

			builder.append(gtids.contains(entry.getKey()) ? "T" : "F" + ";");

//			if(kpidsforEval.contains(entry.getKey())) {
			PIDresult res = new PIDresult();
			res.pid = entry.getKey();
			res.setAct = entry.getValue();
			res.p2Num = mapPid22Pat.get(entry.getKey()) == null? 0 : mapPid22Pat.get(entry.getKey());
//			res.p3Num = mapPid25Pat.get(entry.getKey());
			res.p3Num = 0;
			res.pmNum = mapPid2MPat.get(entry.getKey());
			reslist.add(res);
//			}

			writerRes.println(builder.toString());
			writerRes.flush();
		}
		patterns.printPatterns(bimapAct2Int, "./out/" + foldername + "/patternlog.csv");
		cloPatterns.printPatternsXES(bimapAct2Int, "./out/" + foldername + "/patternlog.xes.gz");
		writerRes.close();

		Collections.sort(reslist, new Comparator<PIDresult>() {
			@Override
			public int compare(PIDresult lhs, PIDresult rhs) {
				// -1 - less than, 1 - greater than, 0 - equal, all inversed for descending
				if (lhs.setAct.size() > rhs.setAct.size()) {
					return -1;
				} else if (lhs.setAct.size() < rhs.setAct.size()) {
					return 1;
				}
				// else
				if (lhs.p2Num > rhs.p2Num) {
					return -1;
				} else if (lhs.p2Num < rhs.p2Num) {
					return 1;
				}
				// else
				if (lhs.p3Num > rhs.p3Num) {
					return -1;
				} else if (lhs.p3Num < rhs.p3Num) {
					return 1;
				}
				// else
				if (lhs.pmNum > rhs.pmNum) {
					return -1;
				} else if (lhs.pmNum < rhs.pmNum) {
					return 1;
				}
				// else
				return 0;
//		        return lhs.setAct > rhs.customInt ? -1 : (lhs.customInt < rhs.customInt) ? 1 : 0;
			}
		});

		ParamEvaluation paramEval = new ParamEvaluation();
//		for (String epid : kpidsforEval) {
//			if (mapPid2Sets.get(epid) != null) {
//				paramEval.p1Threshold = Math.min(mapPid2Sets.get(epid).size(), paramEval.p1Threshold);
//				paramEval.p2Threshold = Math.min(mapPid22Pat.get(epid), paramEval.p2Threshold);
//
//				paramEval.p1ThresholdOR = Math.max(mapPid2Sets.get(epid).size(), paramEval.p1ThresholdOR);
//				paramEval.p2ThresholdOR = Math.max(mapPid22Pat.get(epid), paramEval.p2ThresholdOR);
//
//				if (!mapPid25Pat.isEmpty() && mapPid25Pat.get(epid) != null) {
//					paramEval.pMThreshold = Math.min(mapPid25Pat.get(epid), paramEval.pMThreshold);
//					paramEval.pMThresholdOR = Math.max(mapPid25Pat.get(epid), paramEval.pMThresholdOR);
//				}
//			}
//		}

		PrintStream writerResF1 = UtilIO.createWriter("./out/" + foldername + "/resF1.csv");
		writeColumns(writerResF1);
		
		if(reslist.size() == 0) {
			continue;
		}

		PIDresult res = reslist.get(0);
//		ParamEvaluation newParamEvalnew ParamEvaluation();
		int maxi = res.setAct.size();
		int maxj = res.p2Num;
//		int maxk = res.p3Num;
		int maxn = res.pmNum;

//		Set<String> pidReturned = new THashSet<>();
//		pidReturned.add(res.pid);
//		for (int i = 1; i < reslist.size(); i++) {
//			System.out.println(res.toString());

//			res = reslist.get(i);

//			if(changed(res, newParamEval)) {
		// computeApproxRecall();
		int numReturned = -1;
		double bestestRes = -1;
		double bestRes = -1;
//		ParamEvaluation bestParam = new ParamEvaluation();
		List<String> bestResEstString = null;
		List<String> bestResString = null;
		for (int i = maxi; i >= 1; i--) {
			for (int j = maxj; j >= 0; j--) {
//				for (int k = maxk; k > 0; k--) {
				int k = 0;
					for (int n = maxn; n >= 0; n--) {

						// updateParam
						ParamEvaluation newParamEval = new ParamEvaluation();
						newParamEval.p1Threshold = i;
						newParamEval.p2Threshold = j;

						newParamEval.p3Threshold = k;
						newParamEval.pMThreshold = n;

						Set<String> pidReturned = new THashSet<>();
						for (Entry<String, Set<Integer>> entry : mapPid2Sets.entrySet()) {
//			List<String> res = new ArrayList<>();
//			res.add(e)
							if (isSatifiedThreshold(entry.getKey(), entry.getValue().size(),
									mapPid22Pat.get(entry.getKey()), 0, //mapPid25Pat.get(entry.getKey()),
									mapPid2MPat.get(entry.getKey()), newParamEval)) {
								pidReturned.add(entry.getKey());
							}
						}
//					System.out.println("-Change Param-------------------------------");

						if (numReturned != pidReturned.size()) {
							computeRes(kpidsforEval, newParamEval, pidReturned);
							List<String> resStrings = new ArrayList<>();
							resStrings.add(String.valueOf(newParamEval.p1Threshold));
							resStrings.add(String.valueOf(newParamEval.p2Threshold));

							resStrings.add(String.valueOf(newParamEval.p3Threshold));
							resStrings.add(String.valueOf(newParamEval.pMThreshold));

							addRes(newParamEval, resStrings);
							double currentEst = newParamEval.recalldouble;
							double currentRecall = newParamEval.recall;

							computeRes(gtids, newParamEval, pidReturned);
							addRes(newParamEval, resStrings);
							if ((currentEst > bestestRes && currentRecall > 0.8) || currentRecall <= 0.8 ) {
								bestResEstString = new ArrayList<>(resStrings);
								bestestRes = currentEst;
							}
							if (newParamEval.f1 > bestRes) {
								bestResString = new ArrayList<>(resStrings);
								bestRes = newParamEval.f1;
							}

							writerResF1.println(UtilIO.concatenate(resStrings, ";"));

							numReturned = pidReturned.size();
						}

//			} 
//			pidReturned.add(res.pid);
					}
//				}
			}
//		}

		}
		BufferedWriter out = null;
		bestResEstString.add(param.getDataName());
		bestResEstString.add(String.valueOf(param.getK()));
		bestResEstString.add(String.valueOf(param.getMinSupp()));
		bestResEstString.add(param.getAlg().toString());
		bestResEstString.add("TCFSMa");
		
		bestResEstString.add(String.valueOf(res.setAct.size()));
		bestResEstString.add(String.valueOf(res.p2Num));
		bestResEstString.add(String.valueOf(res.pmNum));
		
		bestResString.add(param.getDataName());
		bestResString.add(String.valueOf(param.getK()));
		bestResString.add(String.valueOf(param.getMinSupp()));
		bestResString.add(param.getAlg().toString());
		bestResString.add("Best");
		
		bestResString.add(String.valueOf(res.setAct.size()));
		bestResString.add(String.valueOf(res.p2Num));
		bestResString.add(String.valueOf(res.pmNum));

		try {

			// Open given file in append mode.
			out = new BufferedWriter(new FileWriter("./out/overviewResNew.csv", true));
			out.write(UtilIO.concatenate(bestResEstString, ";") + "\n");
			out.write(UtilIO.concatenate(bestResString, ";") + "\n");
//            out.write(str); 
			out.close();
		} catch (IOException e) {
			System.out.println("exception occoured" + e);
		}

		System.out.println(UtilIO.concatenate(bestResEstString, ";"));
		System.out.println(UtilIO.concatenate(bestResString, ";"));
//		computeRes(gtids, paramEval, pidReturned);
		}}
//		}}
	}

	private void writeColumns(PrintStream writerResF1) {
		List<String> resStrings = new ArrayList<>();
		resStrings.add(String.valueOf("p1Th"));
		resStrings.add(String.valueOf("p2Th"));
		resStrings.add(String.valueOf("pmTh"));

		resStrings.add(String.valueOf("truePosNum"));
		resStrings.add(String.valueOf("pos"));
		resStrings.add(String.valueOf("FP"));
		resStrings.add(String.valueOf("FN"));

		resStrings.add(String.valueOf("Prec"));
		resStrings.add(String.valueOf("recall"));
		resStrings.add(String.valueOf("recallapp"));
		resStrings.add(String.valueOf("f1"));

		resStrings.add(String.valueOf("truePosNum"));
		resStrings.add(String.valueOf("pos"));
		resStrings.add(String.valueOf("FP"));
		resStrings.add(String.valueOf("FN"));

		resStrings.add(String.valueOf("Prec"));
		resStrings.add(String.valueOf("recall"));
		resStrings.add(String.valueOf("recallapp"));
		resStrings.add(String.valueOf("f1"));
		writerResF1.println(UtilIO.concatenate(resStrings, ";"));

	}

	public void addRes(ParamEvaluation newParamEval, List<String> resStrings) {
		resStrings.add(String.valueOf(newParamEval.truePosNum));
		resStrings.add(String.valueOf(newParamEval.postiveNum));
		resStrings.add(String.valueOf(newParamEval.falsePosNum));
		resStrings.add(String.valueOf(newParamEval.falseNegNum));

		resStrings.add(String.valueOf(newParamEval.precision));
		resStrings.add(String.valueOf(newParamEval.recall));
		resStrings.add(String.valueOf(newParamEval.recalldouble));
		resStrings.add(String.valueOf(newParamEval.f1));
	}

	public void computeRes(Set<String> gtids, ParamEvaluation paramEval, Set<String> pidReturned) {
//		System.out.println("---------------------------------");
//		System.out.println(paramEval.toString());
		paramEval.postiveNum = pidReturned.size();
		Set<String> temppidReturned = new THashSet<>(pidReturned);
		temppidReturned.retainAll(gtids);
		paramEval.truePosNum = temppidReturned.size();
		paramEval.falsePosNum = paramEval.postiveNum - paramEval.truePosNum;
		paramEval.falseNegNum = gtids.size() - paramEval.truePosNum;

//		System.out.println("postiveNum " + paramEval.postiveNum);
//		System.out.println("TruePostiveNum " + paramEval.truePosNum);
//		System.out.println("Precision " + String.valueOf(precision));

		paramEval.precision = (double) paramEval.truePosNum / paramEval.postiveNum;
		paramEval.recall = (double) paramEval.truePosNum / gtids.size();
		paramEval.f1 = 2.0 * paramEval.precision * paramEval.recall / (paramEval.precision + paramEval.recall);
		paramEval.recalldouble = Math.pow(paramEval.recall, 2) / paramEval.postiveNum;
//		System.out.println("Precision " + String.valueOf(paramEval.precision));
//		System.out.println("Recall " + String.valueOf(paramEval.recall));
//		System.out.println("Recall^2 " + String.valueOf(paramEval.recalldouble));
//		System.out.println("F1 " + String.valueOf(paramEval.f1));
	}

	private boolean changed(PIDresult res, ParamEvaluation paramEval) {
		return (res.setAct.size() != paramEval.p1Threshold) || (res.p2Num != paramEval.p2Threshold)
				|| (res.p3Num != paramEval.pMThreshold);
	}

	private boolean isSatifiedThreshold(String key, int numP1, Integer numP2, Integer numP3, Integer numPM,
			ParamEvaluation paramEval) {
		int num2P = numP2 == null? 0 : numP2;
		int numMP = numPM == null? 0 : numPM;

		return (numP1 >= paramEval.p1Threshold) && (num2P >= paramEval.p2Threshold) && (numP3 >= paramEval.p3Threshold)
				&& (numMP >= paramEval.pMThreshold);
//		return (numP1 >= paramEval.p1ThresholdOR) || (numP2 >= paramEval.p2ThresholdOR) || (numPM >= paramEval.pMThresholdOR);
	}

	public static String getFolderName(String year, String pGroup, Parameter param) {
		return pGroup + year + "-k" + String.valueOf(param.getK()) + "s" + String.valueOf(param.getMinSupp()) + "-"
				+ param.getAlg().toString();
	}

	private boolean isRepetitation(BiMap<String, Integer> bimapAct2Int, String label, Sequence sequence) {
		List<ItemSimple> items = sequence.get(sequence.size() - 1).getItems();
		for (ItemSimple item : items) {
			if (item.getId() == bimapAct2Int.get(label)) {
				return true;
			}
		}
		return false;
	}

	private void increasePatternFreq(Map<String, Integer> mapPid22Pat, Entry<String, List<Integer>> entry,
			boolean valid) {
		Integer freq2Pat = mapPid22Pat.get(entry.getKey());
		freq2Pat = freq2Pat == null ? 0 : freq2Pat;
		mapPid22Pat.put(entry.getKey(), valid ? freq2Pat + 1 : freq2Pat);
	}

	private String getLabel(String activity, String dbc) {
		return activity + "||" + dbc;
	}

	private void printMap(BiMap<String, Integer> bimapAct2Int, Map<String, Set<String>> mapAct2caseFreq,
			PrintStream writerAct) {
		for (Entry<String, Integer> entry : bimapAct2Int.entrySet()) {
			writerAct.println(
					entry.getKey() + ";" + entry.getValue() + ";" + mapAct2caseFreq.get(entry.getKey()).size());
		}

	}

	public boolean checkPattern(List<Integer> pattern, List<Integer> list) {
//		List<Integer> pattern = new ArrayList<>();

//		List<Integer> trace = new ArrayList<>();

		// Map pattern[i] to indices in Trace
		List<List<Integer>> indexActI = new ArrayList<List<Integer>>();
		Map<Integer, List<Integer>> mapAct2Index = new THashMap<>();
		for (int i = 0; i < pattern.size(); i++) {
			Integer actI = pattern.get(i);
			mapAct2Index.put(actI, new ArrayList<>());
		}

		for (int i = 0; i < list.size(); i++) {
			List<Integer> index = mapAct2Index.get(list.get(i));
			if (index != null) {
				index.add(i);
			}
		}
		for (Entry<Integer, List<Integer>> entry : mapAct2Index.entrySet()) {
			if (entry.getValue().isEmpty()) {
				return false;
			}
		}
		// Faster by index activity.
		List<Integer> list0 = mapAct2Index.get(pattern.get(0));

		int minInd = list0.get(0);
		int maxInd = list0.get(list0.size() - 1);
		boolean valid = true;
		for (int i = 1; i < pattern.size(); i++) {
			Integer actI = pattern.get(i);
			List<Integer> indices = mapAct2Index.get(actI);

			boolean found = false;
			for (Integer j : indices) {
				if (minInd < j) {
					minInd = j;
					found = true;
					break;
				}
			}

			maxInd = indices.get(indices.size() - 1);
			if (maxInd < minInd) {
				found = false;
			}
			if (!found) {
				valid = false;
				break;
			}
		}
		return valid;
		// pruning
//		boolean valid = pruning(indexActI, indexI);
//		if (!valid) {
//			break;
//		}

	}

	private List<Integer> getIndicesForAct(List<Integer> trace, Integer actI) {
		List<Integer> indexI = new ArrayList<>();
		for (int j = 0; j < trace.size(); j++) {
			Integer actJ = trace.get(j);

			if (actJ == actI) {
				indexI.add(j);
			}
		}
		return indexI;
	}

	private boolean pruning(List<List<Integer>> indexActI, List<Integer> indexI) {
		// TODO Auto-generated method stub
		return false;
	}

	private void printMap(Map<Integer, Integer> mapPatternLenght2FreqMap, PrintStream out) {
		for (Entry<Integer, Integer> entry : mapPatternLenght2FreqMap.entrySet()) {
			out.println(entry.getKey() + ":" + entry.getValue());
		}
	}

	private void write(SequenceDatabase database, PrintStream writer) {
		// TODO Auto-generated method stub
		for (Sequence seq : database.getSequences()) {
			String seqString = "";
			for (Itemset itemset : seq.getItemsets()) {
				seqString += getString(itemset);
			}
			seqString += "-2";
			System.out.println(seqString);
			writer.println(seqString);
		}
	}

	private String getString(Itemset itemset) {
		String s = "";
		for (ItemSimple i : itemset.getItems()) {
			s += i + " ";
		}
		s += "-1 ";
		return s;
	}

	private Set<String> getGroundTruthIds(String filePath) {

		LineIterator it = UtilIO.readFile(filePath);
		Set<String> ids = new THashSet<String>();
		while (it.hasNext()) {
			String line = it.nextLine();
			// do something with line

			// nrLines++;
			// writer.println(line);
			// values = line.split(";");
			String[] values = line.split(",");

			String pid = values[0];
			ids.add(pid);
		}

		return ids;
	}

	private void preprocessing() {
		// TODO Auto-generated method stub

		String filePath = "C:\\Users\\xlu330\\_data\\2018 VUmc\\20180907 VUmc verrichting\\Verrichtingen_all_pseudonymized_BI_VUMC_20180910.csv";
		InputStreamReader isr = null;
		File file = null;
		try {
			file = new File(filePath);
			FileInputStream fileInputStream = new FileInputStream(filePath);
			isr = new InputStreamReader(fileInputStream, "unicode");
		} catch (UnsupportedEncodingException | FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		BufferedReader br = new BufferedReader(isr);
		String cur = "";

		LineIterator it = null;
		try {
			it = FileUtils.lineIterator(file, "UTF-8");
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		String fileName = "./20180903 fulllog1.csv";
		String fileNameDBC = "./20180903 dbcCount.csv";
		PrintStream writer = null;
		PrintStream writerDBC = null;

		// writer = null;
		try {
			writer = new PrintStream(new File(fileName));
			writerDBC = new PrintStream(new File(fileNameDBC));
		} catch (IOException e) {
			e.printStackTrace();
		}

		try {
			int lineCount = 0;
			int lineErrorCount = 0;

			// Read columns
			String line = it.nextLine();
			String[] values = line.split(";");
			int countColumns = values.length;

			System.out.println(line);
			Map<Integer, Integer> mapFreq = new THashMap<>();

			Map<String, Set<String>> mapDBC2NumPatients = new THashMap<>();

			while (it.hasNext()) {

				line = it.nextLine();
				// do something with line
				// System.out.println(line);
				values = line.split(";");

				SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
				Date date = null;
				try {
					date = format.parse(values[2].trim().replaceAll("\"\"", ""));
				} catch (ParseException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				Calendar cal = Calendar.getInstance();
				cal.setTime(date);
				int year = cal.get(Calendar.YEAR);
				// int month = cal.get(Calendar.MONTH);
				// Integer count = mapFreq.get(year);
				// if (count == null) {
				// mapFreq.put(year, 1);
				// } else {
				// mapFreq.put(year, count + 1);
				// }
				// String dbc = values[5].trim().replaceAll("\"\"", "");
				// String pid = values[0].trim().replaceAll("\"\"", "");

				if (year > 2014) {
					writer.println(line.replaceAll("\"\"", "\""));
					// System.out.println(values[0].trim().replaceAll("\"\"", "") + ";" +
					// values[2].trim().replaceAll("\"\"", "") + ";" +
					// values[3].trim().replaceAll("\"\"", "") + ";" +
					// values[4].trim().replaceAll("\"\"", "").replaceAll(" +", " ") + ";" +
					// values[5].trim().replaceAll("\"\"", ""));
					// writer.println(pid + ";" + values[2].trim().replaceAll("\"\"", "") + ";" +
					// values[3].trim().replaceAll("\"\"", "") + ";" +
					// values[4].trim().replaceAll("\"\"", "").replaceAll(" +", " ") + ";" + dbc);
					// writer.println(values[0] + ";" + values[2] + ";" + values[3] + ";" +
					// values[4] + ";" + values[5] );
					writer.flush();

				}

				// Set<String> pids = mapDBC2NumPatients.get(dbc);
				// if(pids == null) {
				// pids = new THashSet<>();
				// }
				// pids.add(pid);
				// mapDBC2NumPatients.put(dbc, pids);

				// if (date != null && date.after(format.parse("2016-01-01")) &&
				if (values.length != countColumns) {
					// System.out.println(line);
					lineErrorCount++;
				}

				lineCount++;
				if (lineCount % 10000 == 0) {
					System.out.println(lineCount);
				}
			}
			System.out.println("total " + lineCount);
			System.out.println("total error" + lineErrorCount);
			// for(java.util.Map.Entry<Integer, Integer> entry : mapFreq.entrySet()) {
			// System.out.println(entry.getKey() + " : " + entry.getValue());
			// }

			// System.out.println("total error" + lineErrorCount);
			// for(java.util.Map.Entry<String, Set<String>> entry :
			// mapDBC2NumPatients.entrySet()) {
			// writerDBC.println(entry.getKey() + ":" + entry.getValue().size());
			// writerDBC.flush();
			// }
			//

		} finally {
			LineIterator.closeQuietly(it);
		}
		writer.close();
		writerDBC.close();

		// try {
		// while((cur=br.readLine()) != null) {
		// System.out.println(cur);
		// }
		// } catch (IOException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }
	}

}
